#include "HT46R064.h"

typedef unsigned char u8;
typedef unsigned int  u16;

#pragma vector F_Timer0_Int   	@0x08

#define pLED1			_pb0
#define pLED1On()		pLED1 = 1
#define pLED1Off()		pLED1 = 0

#define pLED2			_pb1
#define pLED2On()		pLED2 = 1
#define pLED2Off()		pLED2 = 0

#define pLED3			_pb3
#define pLED3On()		pLED3 = 1
#define pLED3Off()		pLED3 = 0

#define pLED4			_pb2
#define pLED4On()		pLED4 = 1
#define pLED4Off()		pLED4 = 0

#define pOUT   			_pb4
#define pOUTOn()		pOUT = 1
#define pOUTOff()		pOUT = 0

#define pAuto			_pa4
#define pAutoOn			pAuto == 0

#define pKEY   			_pa4
#define pKEYIn			pKEY == 0
#define pKEYNo			pKEY == 1

#define pCharge			_pa5
#define pChargefull		pCharge == 1

#define pDC				_pa3
#define pDCIn			pDC == 0
#define pDCNo			pDC == 1

/*----------------------------------------------*
 *                                      *
 *----------------------------------------------*/
#define AD_channel_BAT		0
#define	AD_channel_LOAD		1			

/* صѹ(12λAD) */
//  LD0=2.8V ѹ:75K75K
#define 	dBat2V90		2121	 //2.90V
#define 	dBat3V05		2230	 //2.90V
#define     dBat3V10        2276     //3.10V
#define     dBat3V15        2304     //3.15V
#define     dBat3V20        2340     //3.20V 
#define     dBat3V25        2377     //3.25V 
#define     dBat3V30        2413     //3.30V
#define     dBat3V35        2450     //3.35V 
#define     dBat3V40        2486     //3.40V
#define     dBat3V45        2523     //3.45V
#define     dBat3V50        2560     //3.50V
#define     dBat3V55        2596     //3.55V
#define     dBat3V60        2633     //3.60V
#define     dBat3V65        2669     //3.65V 
#define     dBat3V70        2706     //3.70V
#define     dBat3V75        2742     //3.75V
#define     dBat3V80        2779     //3.80V
#define     dBat3V85        2816     //3.85V
#define     dBat3V90        2852     //3.90V 
#define     dBat3V95        2889     //3.95V
#define     dBat4V00        2925     //4.00V
#define     dBat4V05        2962     //4.05V
#define     dBat4V10        2998     //4.10V
#define     dBat4V15        3035     //4.15V
#define     dBat4V20        3072     //4.20V
#define     dBat4V25        3108     //4.25V

/* USBŵ(12λAD) */
// LDO=2.8V ȡ 0.05R
#define DDischarge50mA      7     	//20mA
#define DDischarge2600mA    216     //2.6A ---> USB

#define     DKeyHold    	150     //ʱ(3)
#define     DKeyShort   	8       //̰̱ʱ(100ms)
#define     DFlash1Sec		250

/*----------------------------------------------*
 * RAM                                      *
 *----------------------------------------------*/
#pragma rambank0

u8  status_machine_value;

u8  R_Previous_Level;

u8  R_TimeBase_Counter0;
u8  R_TimeBase_Counter1;
u8  R_TimeBase_Counter2;
u8  R_TimeBase_Counter3;
u8  R_TimeBase_Counter4;

u8  R_Key_cnt;

u16 R_Adc_Bat_mean;

u16 R_Adc_Load_mean;

u8  R_ChargeCheck_cnt;
u8  R_LoadSmall_Count;
u8  R_LoadSmall_Count1;

u8  R_Bat_Discharge;
u8  R_Bat_Discharge1;

u8  R_LedNumber;

u8  R_Led_Flash;
u8  R_Bat_Hold_cnt;

u8  R_Display_cnt;

u8  R_Load_cnt;

u8  R_ChargeFull_cnt;

u8  R_OverCnt;
bit Flag_BatInit;
bit Flag_LowBat;
bit Flag_Load;
bit Flag_Over;
bit Flag_Discharge;
bit Flag_DischargeFirst;
bit Flag_UpSmallLoad;
bit Flag_Charge;
bit Flag_ChargeFirst;
bit Flag_key;
bit Flag_Charge_Full;
bit Flag_250ms;
bit Flag_500ms;
bit f500ms;
bit Flag_1s_0;
bit Flag_1s_1;

/*----------------------------------------------*
 * ROM                                      *
 *----------------------------------------------*/
#pragma norambank

/*****************************************************************************
     : F_Timer0_Int
   : ʱ0жϺÿ4һ
   : void  
   : 
   ֵ  : 
 ú  : 
   : 
*****************************************************************************/
void F_Timer0_Int(void)
{
    R_TimeBase_Counter0++;
	R_TimeBase_Counter1++;
	R_TimeBase_Counter2++;
	R_TimeBase_Counter3++;
	
	/* 250msʱ */
	if(R_TimeBase_Counter0 == 62)
	{
		Flag_250ms = ~Flag_250ms;
		R_TimeBase_Counter0 = 0;
	}		
	/* 500msʱ */
	if(R_TimeBase_Counter1 == 125)
	{
		Flag_500ms = ~Flag_500ms;
		f500ms = 1;
		R_TimeBase_Counter1 = 0;
	}
	/* 1sʱ */	
	if(R_TimeBase_Counter2 == 250)
	{
		R_TimeBase_Counter2 = 0;
		Flag_1s_0 = 1;
		Flag_1s_1 = 1;
		
		if(Flag_Over == 1)
		{
			if(R_OverCnt != 0)
			{
				R_OverCnt--;
			}
			else
			{
				Flag_Over = 0;
				Flag_Discharge = 0;
			}
		}
	}
    /* ÿ12msɨһΰ */
	{
    	if(R_TimeBase_Counter3 >= 3)                         
	    {
	        R_TimeBase_Counter3 = 0;

	        if(Flag_Charge == 0 && R_Previous_Level > 0) //ʱЧ
	        {
		        /* а */
		        if(pKEY == 0)
		        {
		            /* һμ*/
		            if(0 == R_Key_cnt)
		            {
		                Flag_key = 1;
		            }
		            /* ڶοʼȡֵ */
		            else if(1 == R_Key_cnt)
		            {
						if(Flag_Discharge == 0)
						{
							Flag_Discharge = 1;
							pOUTOn();
							Flag_Over = 0;
							R_OverCnt = 0;
							R_LoadSmall_Count = 0;
						}
		            }
		        }
		        else
		        {	
	                R_Key_cnt = 0;
	                Flag_key = 0;
		        }
	
		        /* ΰʱǿƱ12*30ms=360ms޴İ */
		        if(1 == Flag_key)
		        {
		            if(R_Key_cnt <= 30)
		            {
		                R_Key_cnt++;
		            }
		        }
	        }
	    } 
	}
}

/*****************************************************************************
     : F_System_Init
   : ʼMCU
   : void  
   : 
   ֵ  : 
 ú  : 
   : 
*****************************************************************************/
void F_System_Init(void)
{
    _pa   = ((0<<0)|(0<<1)|(0<<2)|(0<<3)|(0<<4)|(0<<5)|(0<<6)|(0<<7));
    _pac  = ((1<<0)|(1<<1)|(0<<2)|(1<<3)|(1<<4)|(1<<5)|(0<<6)|(0<<7));  
    _papu = ((0<<0)|(0<<1)|(0<<2)|(1<<3)|(1<<4)|(0<<5)|(0<<6)|(0<<7));
    _pawk = ((0<<0)|(0<<1)|(0<<2)|(1<<3)|(1<<4)|(0<<5)|(0<<6)|(0<<7));  //DC뻽    

    _pb   = ((0<<0)|(0<<1)|(0<<2)|(0<<3)|(0<<4)|(0<<5)|(0<<6)|(0<<7));  
    _pbc  = ((0<<0)|(0<<1)|(0<<2)|(0<<3)|(0<<4)|(0<<5)|(0<<6)|(0<<7));
    _pbpu = ((0<<0)|(0<<1)|(0<<2)|(0<<3)|(0<<4)|(0<<5)|(0<<6)|(0<<7));	


//--- Set Ht46r064 Control register ADSR ---
//            +----------   TEST: ֻ
//            |+---------   ADONB:  ADCģԴ/ر 
//            ||            0: ADCģԴ 
//            ||            1: ADCģԴر 
//            ||+--------   Bit 5 δ壬Ϊ0
//            |||+-------   Bit 4 δ壬Ϊ0
//            ||||+------   Bit 3 δ壬Ϊ0
//            |||||+++---   ADCʱѡ
//            ||||||||      000:fSYS/2      001:fSYS/8      010:fSYS/32
//            ||||||||      011:δ,ʹ
//            ||||||||      100:fSYSf       101:fSYS/4      110::SYS/16
//            ||||||||      111:δ,ʹ
    _acsr = 0b00000001;     //tADC: 2us
//--- Set Ht46r064 Control register ADCR ---
//            +----------   START:  A/D ת
//            |             010: 
//            |             01  : A/Dת EOCBΪ1
//            |+---------   EOCB: A/Dת־
//            ||            0: A/D ת
//            ||            1: A/D ת
//            ||+++------   PCR2~PCR0: A/D ͨ(HT46R064) 
//            |||||         000: ر A/D ͨ- ADCģرյԴ     101: ʹ PA0~PA3,PC0Ϊ AN0~AN4
//            |||||         001: ʹ PA0 ΪAN0                       110: ʹ PA0~PA3,PC0,PC1Ϊ AN0~AN5
//            |||||         010: ʹ PA0~PA1 Ϊ AN0~AN1              111: ʹ PA0~PA3,PC0,PC1,PC6,PC7Ϊ AN0~AN7
//            |||||         011: ʹ PA0~PA2 Ϊ AN0~AN2
//            |||||         100: ʹ PA0~PA3 Ϊ AN0~AN3
//            |||||+++---   ACS2~ACS0: ѡ A/D ͨ 
//            ||||||||      000: AN0 
//            ||||||||      001: AN1 
//            ||||||||      010: AN2 
//            ||||||||      011: AN3 
//            ||||||||      1xx: δ壬ʹ
    _adcr = 0b00010000;

//--- Set Ht46r064 Control register CTRL0 ---
//Bit7         +--------- δ壬Ϊ0
//Bit6         |+-------- PFDCS: PFDʱԴ 
//             ||         0: timer0
//             ||         1: timer1 T1F: ʱ/1 ж־
//Bit5         ||+------- PWMSEL: PWMģʽѡλ
//             |||        0: 6+2ģʽ
//             |||        1: 7+1ģʽ
//Bit4         |||+------ PWMC1: I/O PWM1 
//             ||||       0: I/O
//             ||||       1: PWM1
//Bit3         ||||+----- PWMC0: I/O PWM0
//             |||||      0: I/O
//             |||||      1: PWM0
//Bit2         |||||+---- PFDC: I/O  PFD
//             ||||||     0: I/O
//             ||||||     1: PFD
//Bit1         ||||||+--- LXTLP: LXT͹Ŀλ
//             |||||||    0: LXT ģʽ
//             |||||||    1: LXT ͹ģʽ
//Bit0         |||||||+-- CLKMOD: ϵͳʱģʽѡλ
//             ||||||||   0: ģʽ C ʹHIRCΪϵͳʱ
//             ||||||||   1: ģʽ C ʹLXTΪϵͳʱ, HIRCֹͣ
//             ||||||||
    _ctrl0 = 0b00101000;    
//--- Set Ht46r06x Control register CTRL1 ---
//Bit 7, 6     ++---------  INTEG1, INTEG0: ⲿжϱش 
//             ||           00:  رж 
//             ||           01:  ش 
//             ||           10:  ½ش 
//             ||           11:  ˫ش 
//Bit 5, 4     ||++-------  TBSEL1, TBSEL0:  ʱѡλ 
//             ||||         00: 2^10(1/fTP) 
//             ||||         01: 2^11(1/fTP) 
//             ||||         10: 2^12(1/fTP) 
//             ||||         11: 2^13(1/fTP) 
//Bit 3~0      ||||++++---  WDTEN3, WDTEN2, WDTEN1, WDTEN0: WDTʹ 
//             ||||||||     1010: WDT ر 
//             ||||||||     ֵ: WDTʹ C  ֵΪ0101 
//             ||||||||     watchdog timer enableѡѡУùʧЧ
//             ||||||||     watchdog timer enableѡر, WDTɴ4λÿر
    _ctrl1 = 0b00111010;        //2^fTBC; ر WDT
//Bit 7~3     +++++------   δ壬  Ϊ0
//            |||||+++---   WS2WS1WS0WDTѡ   
//            ||||||||      000: 2^8tWDTCK      001: 2^9tWDTCK
//            ||||||||      010: 2^10tWDTCK     011: 2^11tWDTCK
//            ||||||||      100: 2^12tWDTCK     101: 2^13tWDTCK
//            ||||||||      110: 2^14tWDTCK     111: 2^15tWDTCK
    _wdts = 0b00000111;
//--- Set Ht46r064  Control register TMR0C ---
//Bit7,6       ++-------- T0M1~T0M0: ѡ TM1 ģʽλ 
//             ||         00: ޿ģʽ
//             ||         01: ģʽ
//             ||         10: ʱģʽ
//             ||         11: ģʽ
//Bit5         ||+------- T0IO[1:0]:ѡ TPnλ
//             |||        T0S: ʱʱԴ
//             |||        0:  fSYS          1:  LXT  
//             |||        T0S ѡ Timer0Timer2ʱ PWMʱԴfTP
//             |||         PWMʹܣ fTP̶fSYS   T0Sá
//Bit4         |||+------ T0ON,ʱؿλ
//             ||||       0: ر
//             ||||       1: 
//Bit3         ||||+----- T0EG:   
//             |||||      ģʽ                Ȳģʽ
//             |||||      0:  ؼ      0: ½ֹͣ
//             |||||      1:  ½ؼ      1: ½ֹͣ
//Bit 2~0      |||||+++-- T0PSC2, T0PSC1, T0PSC0:  ѡʱԤƵ
//             ||||||||   000: fTP      001: fTP/2
//             ||||||||   010: fTP/4    011: fTP/8
//             ||||||||   100: fTP/16   101: fTP/32
//             ||||||||   110: fTP/64   111: fTP/128
    _tmr0c = 0b10000111;  //128 Ƶ
    _tmr0  = 256-125;     //4000000/128/125=250Hz(4Ms)    
//--- Set Ht46r064 Control register TMR1C ---
//Bit7,6         ++-------- T1M1~T1M0: ѡ TM1 ģʽλ
//               ||         00: ޿ģʽ
//               ||         01: ģʽ
//               ||         10: ʱģʽ
//               ||         11: ģʽ
//Bit5           ||+------- T1IO[1:0]:ѡ TPnλ
//               |||        T0S: ʱʱԴ
//               |||        0:  fSYS/4
//               |||        1:  LXT 
//Bit4           |||+------ T1ON,ʱؿλ
//               ||||       0: ر
//               ||||       1: 
//Bit3           ||||+----- T1EG:   
//               |||||      ģʽ                Ȳģʽ
//               |||||      0:  ؼ      0: ½ֹͣ
//               |||||      1:  ½ؼ      1: ½ֹͣ
//Bit 2~0        |||||+++-- δ壬Ϊ0
//               ||||||||
//    _tmr1c = 0b00000000;
                    
//--- Set Ht46r064 Control register INTC0 ---
//Bit7         +--------- δ壬Ϊ0
//Bit6         |+-------- ADF: A/D ת ж־
//             ||         0: 
//             ||         1: 
//Bit5         ||+------- T0F: ʱ/0 ж־λ
//             |||        0: 
//             |||        1: 
//Bit4         |||+------ INTF: ⲿж־λ
//             ||||       0: 
//             ||||       1: 
//Bit3         ||||+----- ADE: A/D ת жʹ
//             |||||      0: ر
//             |||||      1: 
//Bit2         |||||+---- T0E: ʱ/ жʹ
//             ||||||     0: ر
//             ||||||     1: 
//Bit1         ||||||+--- INTE: ⲿ жʹ
//             |||||||    0: ر
//             |||||||    1: 
//Bit0         |||||||+-- EMI: жʹ
//             ||||||||   0: ر
//             ||||||||   1: 
//             ||||||||
    _intc0 = 0b00000100;       //Timer0ж
//--- Set Ht46r064  Control register INTC1 ---
//Bit7         +--------- δ壬Ϊ0
//Bit6         |+-------- δ壬Ϊ0
//Bit5         ||+------- δ壬Ϊ0
//Bit4         |||+------ TBF: ʱ ж־
//             ||||       0: 
//             ||||       1: 
//Bit3         ||||+----- δ壬Ϊ0
//Bit2         |||||+---- δ壬Ϊ0
//Bit1         ||||||+--- δ壬Ϊ0
//Bit0         |||||||+-- TBE: ʱжʹ
//             ||||||||   0: ر
//             ||||||||   1: 
    _intc1 = 0b00000000;       
}

/*****************************************************************************
     : F_Ram_Init
   : RAM
   : void  
   : 
   ֵ  : 
 ú  : 
   : 
*****************************************************************************/
void F_Ram_Init(void)
{
    _mp0 = 0x40;
    #asm
    mov     a,080H-040H
L_ClrRam:
    clr     __iar0
    inc     __mp0
    sdz     __acc
    jmp     L_ClrRam
    #endasm     
}

/*****************************************************************************
     : F_Status_Check
   : ״̬״̬
   :   
   : 
   ֵ  : 
 ú  : 
   : 
*****************************************************************************/
void F_Status_Check(void)
{
    /* ģʽ */
    if(Flag_Charge == 1)
    {
    	status_machine_value = 1;
    }
    /* ŵģʽ */
    else if(Flag_Discharge == 1)
    {
     	status_machine_value = 2;            
    }
    /* ģʽ */
    else
    {
        status_machine_value = 0;
    }
}

/*----------------------------------------------*
 * ADCӺ                                    *
 *----------------------------------------------*/
u16 F_ADC(u8 channel)
{
	u8 i;
	u16 ad_max = 0;
	u16 ad_min = 0;
	u16 ad_buf = 0;
	u16 ad_res = 0;
	_acsr = 0b00000001;     //tADC: 2us
//--- Set Ht46r064 Control register ADCR ---
//            +----------   START:  A/D ת
//            |             010: 
//            |             01  : A/Dת EOCBΪ1
//            |+---------   EOCB: A/Dת־
//            ||            0: A/D ת
//            ||            1: A/D ת
//            ||+++------   PCR2~PCR0: A/D ͨ(HT46R064) 
//            |||||         000: ر A/D ͨ- ADCģرյԴ     101: ʹ PA0~PA3,PC0Ϊ AN0~AN4
//            |||||         001: ʹ PA0 ΪAN0                       110: ʹ PA0~PA3,PC0,PC1Ϊ AN0~AN5
//            |||||         010: ʹ PA0~PA1 Ϊ AN0~AN1              111: ʹ PA0~PA3,PC0,PC1,PC6,PC7Ϊ AN0~AN7
//            |||||         011: ʹ PA0~PA2 Ϊ AN0~AN2
//            |||||         100: ʹ PA0~PA3 Ϊ AN0~AN3
//            |||||+++---   ACS2~ACS0: ѡ A/D ͨ 
//            ||||||||      000: AN0 
//            ||||||||      001: AN1 
//            ||||||||      010: AN2 
//            ||||||||      011: AN3 
//            ||||||||      1xx: δ壬ʹ
    _adcr = 0b00011000 | channel;    
    
    for(i = 0;i < 10;i++)
    {
        _start = 0;
        _start = 1;
        _start = 0;
        while( _eocb == 1);
		if(i > 3)
		{
        	ad_buf = _adrh;
        	ad_buf <<= 4;
        	ad_buf += (_adrl >> 4);
	        ad_res += ad_buf;
					
			if(i == 4)
			{
				ad_max = ad_buf;
				ad_min = ad_buf;
			}
			else
			{
				if(ad_max < ad_buf)				//ȡֵ
				{
					ad_max = ad_buf;
				}
				
				if(ad_min > ad_buf)				//ȡСֵ
				{
					ad_min = ad_buf;
				}
			}
		}
	}
	ad_res = ad_res - ad_max;					//ȥֵ
	ad_res = ad_res - ad_min;					//ȥСֵ
	
	return (ad_res/4);	
}

/*****************************************************************************
     : F_BatInit
   : ϵʼȼ
   : void  
   : 
   ֵ  : 
 ú  : 
   : 
*****************************************************************************/
void F_BatInit(void)
{
	R_Adc_Bat_mean = F_ADC(AD_channel_BAT);    
	if(R_Adc_Bat_mean <= dBat3V10)
	{
		R_Previous_Level = 0;
	}
	else if(R_Adc_Bat_mean <= dBat3V55)
	{
		R_Previous_Level = 1;
	}
	else if(R_Adc_Bat_mean <= dBat3V75)
	{
		R_Previous_Level = 2;
	}
	else if(R_Adc_Bat_mean <= dBat3V90)
	{
		R_Previous_Level = 3;
	}
	else
	{
		R_Previous_Level = 4;
	}       
}

/*****************************************************************************
     : F_Charge_Check
   : DCȥ
   : void  
   : 
   ֵ  : 
 ú  : 
   : 
*****************************************************************************/
void F_Charge_Check(void)
{
	if(Flag_Charge == 0)
    {
        if(pDCIn)
        {
			R_ChargeCheck_cnt++;
			if(R_ChargeCheck_cnt > 50)
			{
				R_ChargeCheck_cnt = 0;
				Flag_Charge = 1;            //ѽ
				Flag_Charge_Full = 0;
				Flag_ChargeFirst = 1;
				pOUTOff();
				Flag_Discharge = 0;
				Flag_Over = 0;
				R_OverCnt = 0;
				Flag_LowBat = 0;
				R_LoadSmall_Count = 0;
				R_Key_cnt = 0;
				Flag_key = 0;
				R_LedNumber = 0;
				R_Display_cnt = 0;
				f500ms = 0;
			}
        }
		else
		{
			R_ChargeCheck_cnt = 0;
		}
    }
    else
    {
        if(pDCNo)
        {
			R_ChargeCheck_cnt++;
			if(R_ChargeCheck_cnt > 10)
			{
				R_ChargeCheck_cnt = 0;
				Flag_Charge = 0;
				Flag_Charge_Full = 0;
				Flag_Discharge = 1;
				pOUTOn();
			}
        }
		else
		{
			R_ChargeCheck_cnt = 0;
		}
    }	
}

/*****************************************************************************
     : F_Charge_Fun
   : 
   : void  
   : 
   ֵ  : 
 ú  : 
   : 
*****************************************************************************/
void F_Charge_Fun(void)
{
	if(Flag_Charge == 1)
	{		
		if(Flag_Charge_Full == 0)
		{
			R_Adc_Bat_mean = F_ADC(AD_channel_BAT);
			switch(R_Previous_Level)
			{
				case 0:
					if(R_Adc_Bat_mean > dBat3V75)
					{
						R_Bat_Hold_cnt++;
						if(R_Bat_Hold_cnt > 10)
						{
							R_Bat_Hold_cnt = 0;
							R_Previous_Level = 1;
						}
					}
					else
					{
						R_Bat_Hold_cnt = 0;
					}
				break;			
				case 1:
					if(R_Adc_Bat_mean > dBat3V90)
					{
						R_Bat_Hold_cnt++;
						if(R_Bat_Hold_cnt > 10)
						{
							R_Bat_Hold_cnt = 0;
							R_Previous_Level = 2;
						}
					}
					else
					{
						R_Bat_Hold_cnt = 0;
					}			
				break;
				case 2:
					if(R_Adc_Bat_mean > dBat4V10)
					{
						R_Bat_Hold_cnt++;
						if(R_Bat_Hold_cnt > 10)
						{
							R_Bat_Hold_cnt = 0;
							R_Previous_Level = 3;
						}
					}
					else
					{
						R_Bat_Hold_cnt = 0;
					}			
				break;
				case 3:
					if(R_Adc_Bat_mean > dBat4V20)
					{
						R_Bat_Hold_cnt++;
						if(R_Bat_Hold_cnt > 10)
						{
							R_Bat_Hold_cnt = 0;
							R_Previous_Level = 4;
						}
					}
					else
					{
						R_Bat_Hold_cnt = 0;
					}			
				break;				
			}
		}
		
		if(pCharge == 1)
		{
			if(1 == Flag_1s_1)
			{
				Flag_1s_1 = 0;
				R_ChargeFull_cnt++;
				if(R_ChargeFull_cnt > 5)
				{
					R_ChargeFull_cnt = 0;
					Flag_Charge_Full = 1;
					R_Previous_Level = 4;
				}
			}			
		}
	}
}

/*****************************************************************************
     : F_CloseDisCharge
   : رշŵ
   : void  
   : 
   ֵ  : 
 ú  : 
   : 
*****************************************************************************/
void F_CloseDisCharge(void)
{
    pOUTOff();
	Flag_Over = 0;
	Flag_UpSmallLoad = 0;
	R_LoadSmall_Count = 0;
	R_LoadSmall_Count1 = 0;
	R_OverCnt = 0;
}

/*****************************************************************************
     : F_Discharge_Fun
   : ŵ
   : void  
   : 
   ֵ  : 
 ú  : 
   : 
*****************************************************************************/
void F_Discharge_Fun(void)
{
    /* ص0رշŵ */
    if(R_Previous_Level == 0)
    {
		F_CloseDisCharge();
		Flag_Discharge = 0;
    }
    
    if(Flag_Discharge == 1)
    {
		R_Adc_Bat_mean = F_ADC(AD_channel_BAT);
		R_Adc_Load_mean = F_ADC(AD_channel_LOAD);

        /* ŵǷ2.6A׶ */
        if(R_Adc_Load_mean > DDischarge2600mA)
        {
			F_CloseDisCharge();
			Flag_Over = 1;
			R_OverCnt = 5;
        }
        /* USBؼ,10S⵽صС20maرUSB */
		if(0 == Flag_Over)
		{
	        if(R_Adc_Load_mean <= DDischarge50mA)
	        {
	            if(Flag_1s_0 == 1)
	            {
	                Flag_1s_0 = 0;
	                R_LoadSmall_Count++;
	                if(30 <= R_LoadSmall_Count)
	                {
						F_CloseDisCharge();
						Flag_Discharge = 0;
	                }
	            }
	        }
	        else
	        {
	            R_LoadSmall_Count = 0;	
	        }
		}

		/* жϵص */
		switch(R_Previous_Level)
		{			
			case 1:
				if(R_Adc_Bat_mean <= dBat3V10)
				{
					R_Bat_Hold_cnt++;
					if(R_Bat_Hold_cnt > 10)
					{
						R_Bat_Hold_cnt = 0;
						R_Previous_Level = 0;
						Flag_LowBat = 0;
					}
				}
				else
				{	
					R_Bat_Hold_cnt = 0;
					if(R_Adc_Bat_mean <= dBat3V20)
					{
						Flag_LowBat = 1;
					}
				}			
			break;
			case 2:
				if(R_Adc_Bat_mean <= dBat3V55)
				{
					R_Bat_Hold_cnt++;
					if(R_Bat_Hold_cnt > 10)
					{
						R_Bat_Hold_cnt = 0;
						R_Previous_Level = 1;
					}
				}
				else
				{
					R_Bat_Hold_cnt = 0;
				}			
			break;
			case 3:
				if(R_Adc_Bat_mean <= dBat3V65)
				{
					R_Bat_Hold_cnt++;
					if(R_Bat_Hold_cnt > 10)
					{
						R_Bat_Hold_cnt = 0;
						R_Previous_Level = 2;
					}
				}
				else
				{
					R_Bat_Hold_cnt = 0;
				}			
			break;
			case 4:
				if(R_Adc_Bat_mean <= dBat3V85)
				{
					R_Bat_Hold_cnt++;
					if(R_Bat_Hold_cnt > 10)
					{
						R_Bat_Hold_cnt = 0;
						R_Previous_Level = 3;
					}
				}
				else
				{
					R_Bat_Hold_cnt = 0;
				}			
			break;			
		}
    }
}

/*****************************************************************************
     : F_Display
   : LEDʾ
   : void  
   : 
   ֵ  : 
 ú  : 
   : 
*****************************************************************************/
void F_Display(void)
{
	if((1 == Flag_Charge) && (0 == Flag_Discharge))
	{
		if(1 == Flag_ChargeFirst)
		{	
			switch(R_Display_cnt)
			{
				case 0:
					pLED1On();
					break;
				case 1:
					pLED1Off();
					pLED2On();
					break;
				case 2:
					pLED2Off();
					pLED3On();
					break;
				case 3:
					pLED3Off();
					pLED4On();
					break;
				case 4:
					pLED4Off();
					break;
			}
			
			if(R_Display_cnt < 5)
			{
				if(1 == f500ms)
				{
					f500ms = 0;
					R_Display_cnt++;
				}
			}
			else
			{
				Flag_ChargeFirst = 0;
			}			
		}
		else
		{
			if(Flag_Charge_Full == 0)
			{
				if(1 == f500ms)
				{
					f500ms = 0;
					R_LedNumber++;
					if(R_LedNumber > 4)
					{
						if(R_Previous_Level < 4)
						{
							R_LedNumber = R_Previous_Level;
						}
						else
						{
							R_LedNumber = 3;
						}
					}
				}
			}
			else
			{
				R_LedNumber = 4;
			}	
		}
	}
	else if((1 == Flag_Discharge) && (0 == Flag_Charge))
	{
		{
			if(0 == Flag_Over)
			{
				if(0 == Flag_LowBat)
				{
					if(0 == Flag_500ms)
					{
						R_LedNumber = R_Previous_Level;
					}
					else
					{
						if(R_Previous_Level > 0)
						{
							R_LedNumber = R_Previous_Level - 1;
						}
					}
				}
				else
				{
					if(0 == Flag_250ms)
					{
						R_LedNumber = 1;
					}
					else
					{
						R_LedNumber = 0;
					}
				}
			}
			else
			{
				if(0 == Flag_500ms)
				{
					R_LedNumber = 4;
				}
				else
				{
					R_LedNumber = 0;
				}
			}
		}
	}
	else
	{
		R_LedNumber = 0;
	}
	
	if(0 == Flag_ChargeFirst)
	{
		switch(R_LedNumber)
		{
			case 0:
				pLED1Off();
				pLED2Off();
				pLED3Off();
				pLED4Off();
				break;
			case 1:
				pLED1On();
				pLED2Off();
				pLED3Off();
				pLED4Off();
				break;
			case 2:
				pLED1On();
				pLED2On();
				pLED3Off();
				pLED4Off();
				break;
			case 3:
				pLED1On();
				pLED2On();
				pLED3On();
				pLED4Off();
				break;
			case 4:
				pLED1On();
				pLED2On();
				pLED3On();
				pLED4On();
				break;			
		}
	}
}

/*****************************************************************************
     : F_Halt
   : 
   : void  
   : 
   ֵ  : 
 ú  : 
   : 
*****************************************************************************/
void F_Halt(void)
{
	if((Flag_Charge == 0) && (Flag_Discharge == 0) && (Flag_Over == 0) && (R_Key_cnt == 0) && (R_ChargeCheck_cnt == 0) && (pKEYNo) && (pDCNo))
	{	
		_pb   &= 0b11100000;		
		_acsr  = 0b01000000;						//ADCԴ
		_adcr  = 0b00000000;
		R_LedNumber = 0;
        _nop();
        _halt();									//˯
        _nop();       
        _clrwdt();									//߱Ѻι
        if(1 == Flag_BatInit)
        {
			Flag_BatInit = 0;
			F_BatInit();
		}
		if(0 == R_Previous_Level)
		{
			if(pKEYIn)
			{
				R_Adc_Bat_mean = F_ADC(AD_channel_BAT);
				if(R_Adc_Bat_mean > dBat3V35)
				{
					R_Previous_Level = 1;
				}
			}
		}
	}
}

void main()
{
	if(_pdf == 0)
	{
		F_System_Init();
		F_Ram_Init();
		Flag_BatInit = 1;
	    _t0on = 1;										//ʱ0ж
	    _emi = 1;										//MCUж	
	}
	while(1)
	{
        _clrwdt();									//ι
	    F_Charge_Check();							//DC
	    F_Status_Check();                           //״̬״̬       
	    switch(status_machine_value)                //״̬
	    {
			/* ģʽ */
			case 0:
				break;
			/* ģʽ */
	        case 1:
	            F_Charge_Fun(); 					//紦
	            break;
	        /* ŵģʽ */    
	        case 2:
	            F_Discharge_Fun();					//ŵ紦
	            break;              
	    }
     	F_Display();								//ʾ
        F_Halt();									//   	
   	}			
}
